#include <Array.au3>
#include <APIRegConstants.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WinAPIReg.au3>
#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Outfile=InstallCheck.exe
#AutoIt3Wrapper_Res_Description=InstallCheck
#AutoIt3Wrapper_Res_Fileversion=1.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

Opt('GUIOnEventMode', 1)

Global $sTitle = 'InstallCheck'
Global $sVersion = '1.0.0.0'
Global $sDate = '14.10.2016'
Global $sDatafile = @ScriptDir & '\InstallCheck.txt'

Global $aProgramData, $iCount = 0, $aidPrograms[1][4], $iDepartmentCount = 0, $aDepartment

Global $hMainGui = GUICreate(StringFormat('%s v%3.3s', $sTitle, $sVersion), 1250, 600, -1, -1) ; das Fenster erstellen
GUISetBkColor(0xEEEEEE) ; Hintergrundfarbe fr das Fenster festlegen
GUISetIcon('imageres.dll', -105) ; Icon fr das Fenster festlegen
GUISetOnEvent($GUI_EVENT_CLOSE, '_CloseMainGui') ; Funktion die beim schlieen des Fensters aufgerufen wird

GUICtrlCreateButton('', 4, 8, 42, 42, $BS_ICON) ; Button zum erneuten Testen der installierten Programme
GUICtrlSetImage(-1, 'shell32.dll', -239) ; Icon festlegen
GUICtrlSetOnEvent(-1, '_CheckInstalledPrograms') ; Funktion die beim anklicken aufgerufen wird
GUICtrlSetTip(-1, 'Installation testen') ; Tooltip fr den Button
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKSIZE)

Global $idSelDepartment = GUICtrlCreateCombo('', 52, 10, 244, 50, $CBS_DROPDOWNLIST)
GUICtrlSetResizing(-1, $GUI_DOCKLEFT + $GUI_DOCKTOP + $GUI_DOCKSIZE)
GUICtrlSetFont(-1, 18, 400, 0, 'Times New Roman', 5) ; Schriftart und -gre festlegen
GUICtrlSetOnEvent(-1, '_ReadDatafile')

_CreateDepartments() ; die Abteilungsnummern einlesen und der Combobox zuweisen
_ReadDatafile() ; die Datei mit den Datei-Pfaden einlesen und Gui-Elemente erstellen
GUISetState(@SW_SHOW, $hMainGui) ; das Fenster anzeigen
WinWaitClose($hMainGui)
Exit

Func _CloseMainGui()
;~ 	If MsgBox(4 + 32 + 256, $sTitle, 'Soll das Programm wirklich beendet werden?', 0, $hMainGui) = 7 Then Return
	GUIDelete($hMainGui)
EndFunc   ;==>_CloseMainGui

Func _CheckInstalledPrograms()
	If $iCount = 0 Then Return ; wenn kein Programm in der Datendatei steht, dann Funktion verlassen
	Local $err = 0, $hKey = 0
	For $i = 0 To $iCount - 1 ; Schleife, um alle Programme durchzugehen
		If Not FileExists($aProgramData[$i * 5 + 2]) Then ; wenn der Dateipfad nicht existiert, dann ist es vielleicht ein Registrypfad
			$hKey = _WinAPI_RegOpenKey($HKEY_CURRENT_USER, $aProgramData[$i * 5 + 2]) ; testen, ob in HKCU
			$err = @error ; Fehlerwert speichern
			If $err Then ; wenn nicht in HKCU, dann...
				$hKey = _WinAPI_RegOpenKey($HKEY_LOCAL_MACHINE, $aProgramData[$i * 5 + 2]) ; testen, ob in HKLM
				$err = @error ; Fehlerwert speichern
			EndIf
		EndIf
		If Not $err Then ; wenn kein Fehler aufgetreten ist (Programm ist installiert), dann...
			If $hKey Then _WinAPI_RegCloseKey($hKey) ; evtl. geffneten RegKey schlieen
			GUICtrlSetImage($aidPrograms[$i][0], 'imageres.dll', -102) ; grnen Haken setzen
		Else ; ansonsten (Programm nicht installiert)
			GUICtrlSetImage($aidPrograms[$i][0], 'imageres.dll', -101) ; rotes Kreuz setzen
		EndIf
;~ 		ConsoleWrite($aProgramData[$i * 4] & '  "' & $aProgramData[$i * 5 + 2] & '" = ' & $err & @CRLF)
	Next
EndFunc   ;==>_CheckInstalledPrograms

Func _CreateDepartments()
	Local $sData = FileRead($sDatafile) ; Datei mit den Installationsdaten einlesen
	$sData = StringReplace($sData, @CRLF & @CRLF, @CRLF) ; evtl. Leerzeilen entfernen
	$sData = StringRegExpReplace($sData, '(\h*;.*?\r\n)', '') ; die Kommentare entfernen
	$aProgramData = StringSplit($sData, @CRLF, 3) ; und beim Zeilenumbruch splitten
	Local $aTmp, $sDepartment = 'Abteilung 1|' ; Variablen zum ermitteln der Abteilungsnummern
	For $i = 0 To UBound($aProgramData) - 1 Step 5 ; Schleife, um alle Programmdaten durchzugehen
		$aTmp = StringSplit($aProgramData[$i], ',', 2) ; jeweils die erste Zeile (Abteilungsnummern) splitten
		For $j = 0 To UBound($aTmp) - 1 ; alle Abteilungsnummern bearbeiten
			If Number($aTmp[$j]) > 0 And Not StringInStr($sDepartment, $aTmp[$j]) Then ; wenn Abteilungsnr. grer als Null und noch nicht gespeichert, dann...
				$sDepartment &= 'Abteilung ' & $aTmp[$j] & '|' ; Abteilungsnr. speichern
			EndIf
		Next
	Next
	$sDepartment = StringTrimRight($sDepartment, 1) ; letztes Zeichen lschen
	$aDepartment = StringSplit($sDepartment, '|', 2) ; Array mit allen Abteilungsnummern erstellen
	_ArraySort($aDepartment) ; und aufsteigend sortieren
	$sDepartment = _ArrayToString($aDepartment) ; die sortierte Liste wieder in einen String wandeln
	GUICtrlSetData($idSelDepartment, $sDepartment, $aDepartment[0]) ; und der Combobox zuweisen
EndFunc

Func _ReadDatafile()
	Local $sData, $iTop = 60, $iSpace = 46, $iCols = 3, $iSelDepartment
	If $iCount <> 0 Then ; wenn sich auf dem Fenster bereits Gui-Elemente befinden, dann...
		For $i = 0 To $iCount - 1 ; Schleife fr die "Zeilen"
			For $j = 0 To 4 ; Schleife fr die "Spalten"
				GUICtrlDelete($aidPrograms[$i][$j]) ; alle Gui-Elemente lschen
			Next
		Next
	EndIf
	$sData = FileRead($sDatafile) ; Datei mit den Installationsdaten einlesen
	$sData = StringReplace($sData, @CRLF & @CRLF, @CRLF) ; evtl. Leerzeilen entfernen
	$sData = StringRegExpReplace($sData, '(\h*;.*?\r\n)', '') ; die Kommentare entfernen
	$aProgramData = StringSplit($sData, @CRLF, 3) ; und beim Zeilenumbruch splitten
	$iCount = (UBound($aProgramData) - 1) / 5; Anzahl der Programme merken
	ReDim $aidPrograms[$iCount][5] ; das Array neu dimensionieren
	Local $aWinPos = WinGetPos($hMainGui) ; Position und Gre des Fensters holen
	WinMove($hMainGui, '', $aWinPos[0], $aWinPos[1], $aWinPos[2], Ceiling($iCount / $iCols) * $iSpace + $iTop + 30) ; das Fenster in der Gre an die neue Anzahl anpassen
	$iSelDepartment = StringRight(GUICtrlRead($idSelDepartment), 1) ; welche Abteilung wurde ausgewhlt?
	For $i = 0 To $iCount - 1 ; Schleife, um alle Eintrge aus der Datendatei durchzugehen
		If Not StringInStr($aProgramData[$i * 5], 0) And Not StringInStr($aProgramData[$i * 5], $iSelDepartment) Then ContinueLoop ; wenn das Programm nicht fr alle Abteilungen ist und nicht fr die ausgewhlte Abteilung, dann mit dem nchsten Programm fortfahren
		$aidPrograms[$i][0] = GUICtrlCreateIcon('imageres.dll', -100, 8 + Mod($i, $iCols) * 420, $iTop + 4 + Int($i / $iCols) * $iSpace, 32, 32) ; Label fr den Status (rot/grn) erstellen
		GUICtrlSetBkColor(-1, 0xFF0000) ; erstmal auf rot setzen
		$aidPrograms[$i][4] = GUICtrlCreateLabel('', 46 + Mod($i, $iCols) * 420, $iTop + 2 + Int($i / $iCols) * $iSpace, 250, 38, $SS_ETCHEDFRAME)
		$aidPrograms[$i][1] = GUICtrlCreateLabel($aProgramData[$i * 5 + 1], 55 + Mod($i, $iCols) * 420, $iTop + 11 + Int($i / $iCols) * $iSpace, 220, 20) ; das Feld fr den Namen des Programms erstellen
		GUICtrlSetFont(-1, 12, 400, 0, 'Tahoma', 5) ; Schriftart und -gre festlegen
		$aidPrograms[$i][2] = GUICtrlCreateButton('', 300 + Mod($i, $iCols) * 420, $iTop + 2 + Int($i / $iCols) * $iSpace, 46, 38, $BS_ICON) ; Button zum aufrufen des Ordners erstellen
		GUICtrlSetImage(-1, 'shell32.dll', -163, 1) ; Icon fr den Button festlegen
		GUICtrlSetOnEvent(-1, '_OpenFolder') ; diese Funktion wird aufgerufen, wenn auf den Button geklickt wird
;~ 		GUICtrlSetState(-1, $GUI_DISABLE) ; den Button erstmal deaktivieren
		GUICtrlSetTip(-1, 'ffne Setup-Verzeichnis im Explorer') ; den Tooltip fr den Button festlegen
		If Not FileExists($aProgramData[$i * 5 + 3]) Then GUICtrlSetState(-1, $GUI_DISABLE)
		$aidPrograms[$i][3] = GUICtrlCreateButton('', 350 + Mod($i, $iCols) * 420, $iTop + 2 + Int($i / $iCols) * $iSpace, 46, 38, $BS_ICON) ; Button zum aufrufen des Ordners erstellen
		GUICtrlSetImage(-1, 'shell32.dll', -15, 1) ; Icon fr den Button festlegen
		GUICtrlSetOnEvent(-1, '_OpenWebsite') ; diese Funktion wird aufgerufen, wenn auf den Button geklickt wird
		GUICtrlSetTip(-1, 'Homepage aufrufen') ; den Tooltip fr den Button festlegen
		If $aProgramData[$i * 5 + 4] = '//' Then GUICtrlSetState(-1, $GUI_DISABLE)
	Next
	_CheckInstalledPrograms() ; berprfen, ob die Programme installiert sind
EndFunc   ;==>_ReadDatafile

Func _OpenFolder()
	Local $iButton = (5 + @GUI_CtrlId - $aidPrograms[0][2]) / 5 - 1 ; ermitteln welcher Button angeklickt wurde
	Local $sFileFolder = $aProgramData[$iButton * 5 + 3], $sWorkingDir = $sFileFolder
	If Not FileExists($sFileFolder) Then Return
	GUICtrlSetImage($aidPrograms[$iButton][0], 'imageres.dll', -100) ; Icon auf das Fragezeichen setzen
	If Not StringInStr(FileGetAttrib($sFileFolder), 'D') Then ; wenn eine Installationsdatei angegeben wurde, dann...
		$sWorkingDir = StringRegExpReplace($sFileFolder, '(.+\\).+', '$1') ; das WorkingDir ermitteln
	EndIf
	ShellExecute($sFileFolder, '', $sWorkingDir) ; das Verzeichnis / die Datei mit dem Explorer ffnen
EndFunc   ;==>_OpenFolder

Func _OpenWebsite()
	Local $iButton = (5 + @GUI_CtrlId - $aidPrograms[0][3]) / 5 - 1 ; ermitteln welcher Button angeklickt wurde
	ShellExecute($aProgramData[$iButton * 5 + 4]) ; die Website mit dem Standardbrowser ffnen
EndFunc   ;==>_OpenWebsite
